                    PROGRAM

    OMIT('***')
    https://docs.microsoft.com/en-us/windows/desktop/api/iphlpapi/nf-iphlpapi-getadaptersinfo
ULONG               GetAdaptersInfo(
PIP_ADAPTER_INFO    AdapterInfo,
PULONG              SizePointer
    );

typedef             struct _IP_ADAPTER_INFO {
struct              _IP_ADAPTER_INFO *Next;
DWORD               ComboIndex;
char                AdapterName[MAX_ADAPTER_NAME_LENGTH + 4];
char                Description[MAX_ADAPTER_DESCRIPTION_LENGTH + 4];
UINT                AddressLength;
BYTE                Address[MAX_ADAPTER_ADDRESS_LENGTH];
DWORD               Index;
UINT                Type;
UINT                DhcpEnabled;
PIP_ADDR_STRING     CurrentIpAddress;
IP_ADDR_STRING      IpAddressList;
IP_ADDR_STRING      GatewayList;
IP_ADDR_STRING      DhcpServer;
BOOL                HaveWins;
IP_ADDR_STRING      PrimaryWinsServer;
IP_ADDR_STRING      SecondaryWinsServer;
time_t              LeaseObtained;
time_t              LeaseExpires;
    } IP_ADAPTER_INFO, *PIP_ADAPTER_INFO;

    ***

                    MAP
                        module('lphlpapi.dll')
                            GetAdaptersInfo(*cstring pAdapter_info,*long SizePointer),ulong,raw,pascal,name('GetAdaptersInfo')
                        end
                        module('winapi')
                            memcpy(long lpDest,long lpSource,long nCount),long,proc,name('_memcpy')
                        end
                        include('cwutil.inc'),once !*** for ByteToHex ***
                        getIPAndMACAddresses(*cstring pIPAddress,*cstring pMAC)
                    END

theFile             file,driver('ASCII'),CREATE
record                  record
line                        string(100)
                        end
                    end

ipAddress           cstring(21)
MACAddress          cstring(21)

ipAddressQ          QUEUE,pre(IPQ)
Address              cstring(21)
                    end
MACAddressQ         queue,pre(MACQ)
Address                 cstring(21)
                    end
count               long

    CODE
        theFile{PROP:Name} = 'Results.TXT'
        create(theFile)
        open(theFile)
            
        free(ipAddressQ)
        free(MACAddressQ)
        getIPAndMACAddresses(ipAddress,MACAddress)
        
    loop count = 1 to records(ipAddressQ)
        get(ipAddressQ,count)
        if not errorcode()
            theFile.line = 'IP Address ' & IPQ:Address
            add(theFile)
        END
    END

    loop count = 1 to records(MACAddressQ)
        get(MACAddressQ,count)
        if not errorcode()
            theFile.line = 'MAC Address ' & MACQ:Address
            add(theFile)
        END
    END

    close(theFile)
    run('notepad.exe ' & path() & '\Results.txt')


getIPAndMACAddresses        procedure(*cstring pIPAddress,*cstring pMAC)        

dummyBuffer                     cstring(100)
theBuffer                       &cstring

IP_ADAPTER_INFO                 group,pre(IP)
next                                long
ComboIndex                          long
AdapterName                         cstring(260)
Description                         cstring(132)
AddressLength                       long
Address                             byte,dim(8)
Index                               long
type                                long
DhcpEnabled                         long
CurrentIpAddress                    cstring(16)
IpAddressList                       cstring(16)
GatewayList                         cstring(16)
DhcpServer                          cstring(16)
HaveWins                            long
PrimaryWinsServer                   cstring(16)
SecondaryWinsServer                 cstring(16)
LeaseObtained                       long
LeaseExpires                        long
                                end

theRequiredSize                 long
result                          long
!macAddress                      string(17)

    code
        result = GetAdaptersInfo(dummyBuffer,theRequiredSize)
        theBuffer &= new(cstring(theRequiredSize+1))        
        
        result = GetAdaptersInfo(theBuffer,theRequiredSize)
        if result
        else            
            result = memcpy(address(IP_ADAPTER_INFO),address(theBuffer),size(IP_ADAPTER_INFO))
                IPQ:Address = IP:DhcpServer
                add(ipAddressQ)
            
                pIPAddress = IP:DhcpServer
                pMAC = ByteToHex(IP:Address[1]) & '-' & ByteToHex(IP:Address[2]) & '-' & |
                    ByteToHex(IP:Address[3]) & '-' & ByteToHex(IP:Address[4]) & '-' & |
                    ByteToHex(IP:Address[5]) & '-' & ByteToHex(IP:Address[6])
            
            MACQ:Address = pMAC
            add(MACAddressQ)
            
        end
        
        loop while IP:next
            result = memcpy(address(IP_ADAPTER_INFO),IP:next,size(IP_ADAPTER_INFO))
                pIPAddress = IP:DhcpServer
                IPQ:Address = IP:DhcpServer
                get(ipAddressQ,IPQ:Address)
                if errorcode()
                    add(ipAddressQ)
                end
            
                pMAC = ByteToHex(IP:Address[1]) & '-' & ByteToHex(IP:Address[2]) & '-' & |
                    ByteToHex(IP:Address[3]) & '-' & ByteToHex(IP:Address[4]) & '-' & |
                    ByteToHex(IP:Address[5]) & '-' & ByteToHex(IP:Address[6])  
            
            MACQ:Address = pMAC
            get(MACAddressQ,MACQ:Address)
            if errorcode()
                add(MACAddressQ)
            end            
            
        end       
        
        dispose(theBuffer)
        
        
